#############################################################################################
#############################################################################################
##
## COMMANDS GO
##
#############################################################################################
#############################################################################################

# path and binaries
GO               := go
GOLINT           := golint

EXECUTABLES = $(EXECUTABLES:-) $(GO) $(GOLINT); 

ifeq ($(shell command -v $(GO) 2> /dev/null),)
  $(error "go is not installed. Please install go <https://go.dev/doc/install>")
endif

GOPATH=$(shell go env GOPATH)

ifeq ($(GOPATH),)
    DIRS := bin pkg src
    GOPATH=$(DEPLOYMENT_PATH)/go/
    $(shell mkdir -p $(GOPATH))
	$(shell $(foreach entry,$(DIRS),mkdir -p "$(GOPATH)$(entry)";))
    export PATH=$(PATH):$(GOPATH)/bin
endif

ifdef SOURCE_PATH
	PKG_LIST := $(shell if [ -d "SOURCE_PATH" ] ; then cd $(SOURCE_PATH); $(GO) list ./... | grep -v /vendor/ ; fi)
    GO_FILES := $(shell if [ -d "SOURCE_PATH" ] ; then cd $(SOURCE_PATH); find . -name '*.go' | grep -v /vendor/ | grep -v _test.go; fi)
endif


